import math
import numpy as np

# Original G is 6.6742*10**-11
# So if our units are in the millions
G = 6.6742 * 10 ** -5


def distance(s1, s2):
    return math.sqrt(sum(((s1[0] - s2[0])**2, (s1[1] - s2[1])**2)))


def force(m1, m2, s):
    return (G * m1 * m2) / s ** 2


def angle(vec1, vec2):
    # return math.atan2(vec2[1] - vec1[1], vec2[0] - vec1[0])
    return np.arctan2(vec2[1] - vec1[1], vec2[0] - vec1[0])


def forceVec(vec1, vec2):
    """Calculate the force vector between vec1 and vec2, where vec1 and vec2 are like [x, y, mass]

    The force vector should be of the form [Fx, Fy]
    """
    vec1 = np.array(vec1)
    vec2 = np.array(vec2)
    mass1 = vec1[2]
    mass2 = vec2[2]
    print(distance(vec1, vec2))
    F = force(mass1, mass2, distance(vec1, vec2))
    θ = angle(vec1, vec2)
    # return np.array([F * np.cos(θ), F * np.sin(θ)])  # array
    # return [F * np.cos(θ), F * np.sin(θ)]  # list
    return F * np.cos(θ), F * np.sin(θ)  # tuple
